/*****************************************************************************/
/*                                                                           */
/*  HyperPanel VMOS                     File "include/vmio.h"                */
/*  Prototypes of general I/O container procedures                          */
/*                                                                           */
/*  Author : JYA                        Last modification : 04/11/2016       */
/*                                                                           */
/*  (c) Copyright HyperPanel Lab, All Rights Reserved                        */
/*  IDDN.FR.001.320001.*.S.P.1990.000.10000                                  */
/*                                                                           */
/*****************************************************************************/


/*  Some explanations =======================================================


         1  Defines
         2  Structures and typedefs
         3  Public variables
         4  Prototypes of public procedures


*/


#ifndef VMIO_H                         /* If this file is not already        */
#define VMIO_H                         /* included, include it.              */


/*
    1    Defines
    ____________
*/


/*
    2    Structures and typedefs
    ____________________________
*/


/*
    3    Public variables
    _____________________
*/

extern S_evt           c_evt         ; /* Evenement courant                  */
extern USHORT          numauto_s     ; /* Numero de l'automate concerne      */
extern USHORT          voielog_s     ; /* Numero VL courante                 */
extern USHORT          condition_s   ; /* <> 0 si condition positionnee      */
extern IWORD           etat_s        ; /* Etat courant de l'automate         */
extern SHORT           code_s        ; /* Code evenement entrant             */

/*
    4    Prototypes of public procedures
    ____________________________________
*/


  IWORD init_auto_s         (IWORD                                           );
  IWORD end_auto_s          (IWORD                                           );
  void  iniaut_s            (IWORD,const S_trans *, const USHORT *,USHORT *  );
  IWORD putevt_vmio         (S_evt*                                          );
  IWORD putevt_vmio_urg     (S_evt*                                          );
  IWORD send_vmio           (S_evt*                                          );
  IWORD stoevt_s            (S_evt*                                          );
  IWORD getevt_s            (IWORD,IWORD*,IWORD,IWORD,S_evt*                 );
  IWORD clrevt_s            (IWORD                                           );
  void  relaut_s            (UINT                                            );
  UINT  setto_s             (UINT,INT,IWORD,IWORD                            );
  IWORD clearto_s           (INT,UINT                                        );
  IWORD trien_s             (INT                                             );
  IWORD evtto_s             (IWORD,IWORD                                     );
  IWORD moteur_s            (IWORD,IWORD                                     );
  IWORD get_autvl           (INT*,INT*                                       );
  IWORD send_resp           (INT,INT,UCHAR*,INT,UINT                         );


#endif                                 /* End of VMIO_H.                     */
