/*
**  Myapp_scr.c - Sample code for STM32 SynapsOS =============== 01/31/19 =  **
**                                                                           **
**  UI screens data                                                          **
**                                                                           **
**  =======================================================================  **
*/



/* ANSI Terminal Cursor control commands ....................................*/

static const char loc_save[]         = "\x1Bs"                               ; 
static const char loc_restore[]      = "\x1Bu"                               ; 
static const char loc_time[]         = "\x1B[3;55H"                          ;
static const char loc_t_coord[]      = "\x1B[16;53H"                         ;
static const char loc_error[]        = "\x1B[9;12H"                         ;

static const char * const loc_cmd[NB_PAGES] = {"\x1B[21;23H", "\x1B[21;23H",
                                               "\x1B[21;23H", "\x1B[21;23H",
                                               "\x1B[21;23H", "\x1B[21;23H",
                                               "\x1B[21;23H", "\x1B[21;23H",
                                               "\x1B[21;23H", "\x1B[21;23H",
                                               "\x1B[21;23H", "\x1B[21;23H",
                                               "\x1B[21;23H", "\x1B[21;23H",
                                               "\x1B[21;23H", "\x1B[21;23H",
                                               "\x1B[21;23H", "\x1B[21;23H",
                                               "\x1B[21;23H", "\x1B[21;23H",
                                               "\x1B[21;23H", "\x1B[21;23H",
                                               "\x1B[21;23H", "\x1B[21;23H",
                                               "\x1B[21;23H", "\x1B[21;23H",
                                               "\x1B[21;23H", "\x1B[21;23H",
                                               "\x1B[21;23H", "\x1B[21;23H",
                                               "\x1B[21;23H", "\x1B[21;23H",
                                               "\x1B[21;23H", "\x1B[21;23H",
                                               "\x1B[21;23H", "\x1B[21;23H",
                                               "\x1B[21;23H", "\x1B[21;23H",
                                               "\x1B[21;23H", "\x1B[21;23H",
                                               "\x1B[21;23H", "\x1B[21;23H",} ;

static const char * const loc_cfg[9][2]     = { "\x1B[8;53H" , "\x1B[8;45H" ,
                                                "\x1B[9;53H" , "\x1B[9;45H" ,
                                                "\x1B[10;53H", "\x1B[10;45H",
                                                "\x1B[11;53H", "\x1B[11;45H",
                                                "\x1B[12;53H", "\x1B[12;45H",
                                                "\x1B[13;53H", "\x1B[13;45H",
                                                "\x1B[14;53H", "\x1B[14;45H",
                                                "\x1B[15;53H", "\x1B[15;45H",
                                                "\x1B[16;53H", "\x1B[16;45H" };

/* Main page MMAIN const data ...............................................*/

static const char *mmain =
"\x1B[2J"                              // Clear screen
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   Main menu                                                  |\n\r"
"  |                                                              |\n\r"
"  |   +---------------------------------------+  +-----------+   |\n\r"
"  |   | 1  Start/Stop pattern on RED          |  |  -------  |   |\n\r"
"  |   | 2  Start/Stop pattern on GREEN        |  |  -------  |   |\n\r"
"  |   | 3  Start/Stop pattern on YELLOW       |  |  -------  |   |\n\r"
"  |   | 4  Start/Stop serial line ASY1        |  |  -------  |   |\n\r"
"  |   | 5  Start/Stop serial line ASY2        |  |  -------  |   |\n\r"
"  |   | 6  Start/Stop audio DAC               |  |  -------  |   |\n\r"
"  |   | 7  Start/Stop UHF RCU transmitter     |  |  -------  |   |\n\r"
"  |   | 8  I2C menu                           |  +-----------+   |\n\r"
"  |   | 9  Configuration menu                 |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   | 0  Restart                            |                  |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |                                                              |\n\r"
"  |   Enter command :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                                ;

static const M_trans tmain[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt,'X'    , pgrp,GMAIN  ,
OPT_2     , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt,'X'    , pgrp,GMAIN  ,
OPT_3     , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt,'X'    , pgrp,GMAIN  ,
OPT_4     , pcmd,'4' , tcfg,VASY1  , rasy,VASY1  , empt,'X'    , pgrp,GMAIN  ,
OPT_5     , pcmd,'5' , tcfg,VASY2  , rasy,VASY2  , empt,'X'    , pgrp,GMAIN  ,
OPT_6     , pcmd,'6' , tcfg,VDAC   , rdac,VDAC   , empt,'X'    , pgrp,GMAIN  ,
OPT_7     , pcmd,'7' , tcfg,VUHFRCU, rrcu,VUHFRCU, empt,'X'    , pgrp,GMAIN  ,
OPT_8     , pcmd,'8' , empt,'X'    , empt,'X'    , pmen,MI2C   , empt,'X'    ,
OPT_9     , pcmd,'9' , empt,'X'    , empt,'X'    , pmen,MCONF  , pgrp,GCONF  ,
OPT_0     , pcmd,'0' , empt,'X'    , rest,'X'    , empt,'X'    , empt,'X'    ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt,'X'    , pgrp,GMAIN  ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt,'X'    , pgrp,GMAIN  ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt,'X'    , pgrp,GMAIN  ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim,'X'    , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RMAIN  , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt,'X'    , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt,'X'    , empt,'X'    ,
}                                                                            ;

static const char *const str_stat[]  = { "stopped", "STARTED"              } ;

static const char *const led_tagpop  = "CMD=POPALL"                          ;

static const char *const tag_led0[]  = { "PATTERN=OFF:0\nCMD=PUSH"        , 
                                         "PATTERN=ON:5,OFF:5\nCMD=PUSH"    } ;

static const char *const tag_led1[]  = { "PATTERN=OFF:0\nCMD=PUSH"        , 
                                         "PATTERN=ON:2,OFF:8\nCMD=PUSH"    } ;

static const char *const tag_led2[]  = { "PATTERN=OFF:0\nCMD=PUSH"        , 
                                         "PATTERN=ON:8,OFF:2\nCMD=PUSH"    } ;


/* I2C menu .................................................................*/

static const char *mi2c =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   I2C menu                                                   |\n\r"
"  |                                                              |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |   | 1 Write 1 byte in EEPROM (fixed addr) |                  |\n\r"
"  |   | 2 Write 5 bytes in EEPROM (fixed addr)|                  |\n\r"
"  |   | 3 Read 1 byte in EEPROM (fixed addr)  |                  |\n\r"
"  |   | 4 Read 3 bytes in EEPROM (fixed addr) |                  |\n\r"
"  |   | 5 Read next 2 bytes in EEPROM         |                  |\n\r"
"  |   | 6 Display 'Hello' on LCD screen       |                  |\n\r"
"  |   | 7 Display 'world' on LCD screen       |                  |\n\r"
"  |   | 8 Clear LCD screen                    |  +-----------+   |\n\r"
"  |   | 9 Get touch coordinates               |  |  -------  |   |\n\r"
"  |   |                                       |  +-----------+   |\n\r"
"  |   | 0  Back to main menu                  |                  |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |                                                              |\n\r"
"  |   Enter command :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                                ;

static const M_trans ti2c[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , empt,'X'    , ewreq,1     , empt,'X'    , empt,'X'    ,
OPT_2     , pcmd,'2' , empt,'X'    , ewreq,5     , empt,'X'    , empt,'X'    ,
OPT_3     , pcmd,'3' , empt,'X'    , eroreq,1    , empt,'X'    , empt,'X'    ,
OPT_4     , pcmd,'4' , empt,'X'    , eroreq,3    , empt,'X'    , empt,'X'    ,
OPT_5     , pcmd,'5' , empt,'X'    , erreq,2     , empt,'X'    , empt,'X'    ,
OPT_6     , pcmd,'6' , empt,'X'    , ldreq,0     , empt,'X'    , empt,'X'    ,
OPT_7     , pcmd,'7' , empt,'X'    , ldreq,1     , empt,'X'    , empt,'X'    ,
OPT_8     , pcmd,'8' , empt,'X'    , lcreq,'X'   , empt,'X'    , empt,'X'    ,
OPT_9     , pcmd,'9' , empt,'X'    , ltcreq,'X'  , empt,'X'    , empt,'X'    ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MMAIN  , pgrp,GMAIN  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt,'X'    , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt,'X'    , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt,'X'    , empt,'X'    ,
OPT_I2C_END,empt,'X' , empt,'X'    , empt,'X'    , pdtc,'X'    , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim,'X'    , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RI2C   , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt,'X'    , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt,'X'    , empt,'X'    ,
}                                                                            ;


/* Choice of configuration menu .............................................*/

static const char *mconf =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   Configuration menu                                         |\n\r"
"  |                                                              |\n\r"
"  |   +---------------------------------------+  +-----------+   |\n\r"
"  |   | 1  Select ASY1 transmit pattern       |  |  -------  |   |\n\r"
"  |   | 2  Select ASY2 transmit pattern       |  |  -------  |   |\n\r"
"  |   | 3  Select DAC transmit pattern        |  |  -------  |   |\n\r"
"  |   |                                       |  +-----------+   |\n\r"
"  |   | 4  Configure serial line ASY1         |                  |\n\r"
"  |   | 5  Configure serial line ASY2         |                  |\n\r"
"  |   | 6  Configure GPIO BUT1/BUT2/BUT3      |                  |\n\r"
"  |   | 7  Configure RCU receiver             |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   | 0  Back to main menu                  |                  |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |                                                              |\n\r"
"  |   Enter command :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                                ;

static const M_trans tconf[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , empt,'X'    , empt,'X'    , pmen,MASY1PT, empt,'X'    ,
OPT_2     , pcmd,'2' , empt,'X'    , empt,'X'    , pmen,MASY2PT, empt,'X'    ,
OPT_3     , pcmd,'2' , empt,'X'    , empt,'X'    , pmen,MDACPT , empt,'X'    ,
OPT_4     , pcmd,'4' , empt,'X'    , empt,'X'    , pmen,MASY1  , pgrp,GASY1  ,
OPT_5     , pcmd,'5' , empt,'X'    , empt,'X'    , pmen,MASY2  , pgrp,GASY2  ,
OPT_6     , pcmd,'6' , empt,'X'    , empt,'X'    , pmen,MGPIO  , pgrp,GGPIO  ,
OPT_7     , pcmd,'7' , empt,'X'    , empt,'X'    , pmen,MRCU   , pgrp,GRCU   ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MMAIN  , pgrp,GMAIN  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt,'X'    , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt,'X'    , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt,'X'    , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim,'X'    , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RCONF  , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt,'X'    , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt,'X'    , empt,'X'    ,
}                                                                            ;
static const char *const str_asypt[] = { "00-->FF", "FF-->00",
                                         "256x 00", "256x AA", "256x FF"   } ;

static const char *const str_dacpt[] = { "PATDAC0", "PATDAC1",
                                         "PATDAC2", "PATDAC3", "PATDAC4"   } ;

/* Select ASY1+ASY2 transmit pattern const data .............................*/

static const char *masypt =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   Select transmit pattern for ####                           |\n\r"
"  |                                                              |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |   | 1  256 bytes 0x00 to 0xFF             |                  |\n\r"
"  |   | 2  256 bytes 0xFF to 0x00             |                  |\n\r"
"  |   | 3  256 bytes 0x00                     |                  |\n\r"
"  |   | 4  256 bytes 0xAA                     |                  |\n\r"
"  |   | 5  256 bytes 0xFF                     |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   | 0  Back to main menu                  |                  |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |                                                              |\n\r"
"  |   Enter command :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                                ;

static const M_trans tasy1pt[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VASY1PT, sapt,VASY1PT, pmen,MCONF  , pgrp,GCONF  ,
OPT_2     , pcmd,'2' , scfg,VASY1PT, sapt,VASY1PT, pmen,MCONF  , pgrp,GCONF  ,
OPT_3     , pcmd,'3' , scfg,VASY1PT, sapt,VASY1PT, pmen,MCONF  , pgrp,GCONF  ,
OPT_4     , pcmd,'4' , scfg,VASY1PT, sapt,VASY1PT, pmen,MCONF  , pgrp,GCONF  ,
OPT_5     , pcmd,'5' , scfg,VASY1PT, sapt,VASY1PT, pmen,MCONF  , pgrp,GCONF  ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MCONF  , pgrp,GCONF  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RCONF  , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const M_trans tasy2pt[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VASY2PT, sapt,VASY2PT, pmen,MCONF  , pgrp,GCONF  ,
OPT_2     , pcmd,'2' , scfg,VASY2PT, sapt,VASY2PT, pmen,MCONF  , pgrp,GCONF  ,
OPT_3     , pcmd,'3' , scfg,VASY2PT, sapt,VASY2PT, pmen,MCONF  , pgrp,GCONF  ,
OPT_4     , pcmd,'4' , scfg,VASY2PT, sapt,VASY2PT, pmen,MCONF  , pgrp,GCONF  ,
OPT_5     , pcmd,'5' , scfg,VASY2PT, sapt,VASY2PT, pmen,MCONF  , pgrp,GCONF  ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MCONF  , pgrp,GCONF  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RCONF  , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

/* Select DAC transmit pattern const data ...................................*/

static const char *mdacpt =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   Select transmit pattern for DAC                            |\n\r"
"  |                                                              |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |   | 1  256 bytes 0x00 to 0xFF             |                  |\n\r"
"  |   | 2  256 bytes 0xFF to 0x00             |                  |\n\r"
"  |   | 3  256 bytes 0x00                     |                  |\n\r"
"  |   | 4  256 bytes 0xAA                     |                  |\n\r"
"  |   | 5  256 bytes 0xFF                     |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   | 0  Back to main menu                  |                  |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |                                                              |\n\r"
"  |   Enter command :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                                ;

static const M_trans tdacpt[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VDACPT , sdpt,VDACPT , pmen,MCONF  , pgrp,GCONF  ,
OPT_2     , pcmd,'2' , scfg,VDACPT , sdpt,VDACPT , pmen,MCONF  , pgrp,GCONF  ,
OPT_3     , pcmd,'3' , scfg,VDACPT , sdpt,VDACPT , pmen,MCONF  , pgrp,GCONF  ,
OPT_4     , pcmd,'4' , scfg,VDACPT , sdpt,VDACPT , pmen,MCONF  , pgrp,GCONF  ,
OPT_5     , pcmd,'5' , scfg,VDACPT , sdpt,VDACPT , pmen,MCONF  , pgrp,GCONF  ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MCONF  , pgrp,GCONF  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RCONF  , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;



/* Serial line options list MASY1+MASY2 const data ..........................*/

static const char *masy  =             
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   Configure serial line ####                                 |\n\r"
"  |                                                              |\n\r"
"  |   +---------------------------------------+  +-----------+   |\n\r"
"  |   | 1  Set baudrate                       |  |  -------  |   |\n\r"
"  |   | 2  Set number of bits per symbol      |  |  -------  |   |\n\r"
"  |   | 3  Set number of stop bits            |  |  -------  |   |\n\r"
"  |   | 4  Set parity bit                     |  |  -------  |   |\n\r"
"  |   | 5  Enable/Disable DMA                 |  |  -------  |   |\n\r"
"  |   | 6  Set flow control                   |  |  -------  |   |\n\r"
"  |   | 7  Set flush mode                     |  |  -------  |   |\n\r"
"  |   | 8  Set flush temporization            |  |  -------  |   |\n\r"
"  |   | 9  Toggle reception speed             |  |  -------  |   |\n\r"
"  |   |                                       |  +-----------+   |\n\r"
"  |   | 0  Back to main menu                  |                  |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |                                                              |\n\r"
"  |   Enter command :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                                ;

static const M_trans tasy1[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , empt,'X'    , empt,'X'    , pmen,MBAUD1 , empt,'X'    ,
OPT_2     , pcmd,'2' , empt,'X'    , empt,'X'    , pmen,MBITS1 , empt,'X'    ,
OPT_3     , pcmd,'3' , empt,'X'    , empt,'X'    , pmen,MSTOP1 , empt,'X'    ,
OPT_4     , pcmd,'4' , empt,'X'    , empt,'X'    , pmen,MPAR1  , empt,'X'    ,
OPT_5     , pcmd,'5' , tcfg,VDMA1  , sval,VDMA1  , empt,'X'    , pgrp,GASY1  ,
OPT_6     , pcmd,'6' , empt,'X'    , empt,'X'    , pmen,MFLOW1 , empt,'X'    ,
OPT_7     , pcmd,'7' , empt,'X'    , empt,'X'    , pmen,MFLUSH1, empt,'X'    ,
OPT_8     , pcmd,'8' , empt,'X'    , empt,'X'    , pmen,MTEMPO1, empt,'X'    ,
OPT_9     , pcmd,'9' , tcfg,VSPEED1, empt,'X'    , empt,'X'    , pgrp,GASY1  ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MCONF  , pgrp,GCONF  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RASY1  , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const M_trans tasy2[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , empt,'X'    , empt,'X'    , pmen,MBAUD2 , empt,'X'    ,
OPT_2     , pcmd,'2' , empt,'X'    , empt,'X'    , pmen,MBITS2 , empt,'X'    ,
OPT_3     , pcmd,'3' , empt,'X'    , empt,'X'    , pmen,MSTOP2 , empt,'X'    ,
OPT_4     , pcmd,'4' , empt,'X'    , empt,'X'    , pmen,MPAR2  , empt,'X'    ,
OPT_5     , pcmd,'5' , tcfg,VDMA2  , sval,VDMA2  , empt,'X'    , pgrp,GASY2  ,
OPT_6     , pcmd,'6' , empt,'X'    , empt,'X'    , pmen,MFLOW2 , empt,'X'    ,
OPT_7     , pcmd,'7' , empt,'X'    , empt,'X'    , pmen,MFLUSH2, empt,'X'    ,
OPT_8     , pcmd,'8' , empt,'X'    , empt,'X'    , pmen,MTEMPO2, empt,'X'    ,
OPT_9     , pcmd,'9' , tcfg,VSPEED2, empt,'X'    , empt,'X'    , pgrp,GASY2  ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MCONF  , pgrp,GCONF  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RASY2  , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const char *const str_baud[]  = { "    600", "   1200", "   2400", 
                                         "   9600", "  19200", "  38400", 
                                         "  57600", " 115200",                        } ;

static const char *const str_bits[]  = { " 6 BITS", " 7 BITS", " 8 BITS"   } ;
static const char *const str_stop[]  = { " 1 STOP", " 2 STOP"              } ;
static const char *const str_par []  = { " NO PAR", "   EVEN", "    ODD"   } ;
static const char *const str_dma []  = { "DMA OFF", " DMA ON"              } ;

static const char *const str_flush[] = { "   FULL", "   CHAR", "  FRAME"   } ;
static const char *const str_flto [] = { "   1 MS", "   5 MS", "  10 MS",
                                         "  50 MS", " 100 MS", " 150 MS",
                                         " 200 MS", " 500 MS", "1000 MS"   } ;

static const char *const str_speed[] = { "   FAST", "   SLOW"              } ;

static const char *const tag_bufsz[] = { "BUFSIZE=64"  , "BUFSIZE=0"       } ;


/* Serial baudrate configuration MBAUD1+MBAUD2 const data ...................*/

static const char *mbaud =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   Select baudrate for ####                                   |\n\r"
"  |                                                              |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |   | 1      600 bauds                      |                  |\n\r"
"  |   | 2    1 200 bauds                      |                  |\n\r"
"  |   | 3    2 400 bauds                      |                  |\n\r"
"  |   | 4    9 600 bauds                      |                  |\n\r"
"  |   | 5   19 200 bauds                      |                  |\n\r"
"  |   | 6   38 400 bauds                      |                  |\n\r"
"  |   | 7   57 600 bauds                      |                  |\n\r"
"  |   | 8  115 200 bauds                      |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   | 0  Back to serial line options        |                  |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |                                                              |\n\r"
"  |   Enter command :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                           ;

static const M_trans tbaud1[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VBAUD1 , sval,VBAUD1 , pmen,MASY1  , pgrp,GASY1  ,
OPT_2     , pcmd,'2' , scfg,VBAUD1 , sval,VBAUD1 , pmen,MASY1  , pgrp,GASY1  ,
OPT_3     , pcmd,'3' , scfg,VBAUD1 , sval,VBAUD1 , pmen,MASY1  , pgrp,GASY1  ,
OPT_4     , pcmd,'4' , scfg,VBAUD1 , sval,VBAUD1 , pmen,MASY1  , pgrp,GASY1  ,
OPT_5     , pcmd,'5' , scfg,VBAUD1 , sval,VBAUD1 , pmen,MASY1  , pgrp,GASY1  ,
OPT_6     , pcmd,'6' , scfg,VBAUD1 , sval,VBAUD1 , pmen,MASY1  , pgrp,GASY1  ,
OPT_7     , pcmd,'7' , scfg,VBAUD1 , sval,VBAUD1 , pmen,MASY1  , pgrp,GASY1  ,
OPT_8     , pcmd,'8' , scfg,VBAUD1 , sval,VBAUD1 , pmen,MASY1  , pgrp,GASY1  ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MASY1  , pgrp,GASY1  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RBAUD1 , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const M_trans tbaud2[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VBAUD2 , sval,VBAUD2 , pmen,MASY2  , pgrp,GASY2  ,
OPT_2     , pcmd,'2' , scfg,VBAUD2 , sval,VBAUD2 , pmen,MASY2  , pgrp,GASY2  ,
OPT_3     , pcmd,'3' , scfg,VBAUD2 , sval,VBAUD2 , pmen,MASY2  , pgrp,GASY2  ,
OPT_4     , pcmd,'4' , scfg,VBAUD2 , sval,VBAUD2 , pmen,MASY2  , pgrp,GASY2  ,
OPT_5     , pcmd,'5' , scfg,VBAUD2 , sval,VBAUD2 , pmen,MASY2  , pgrp,GASY2  ,
OPT_6     , pcmd,'6' , scfg,VBAUD2 , sval,VBAUD2 , pmen,MASY2  , pgrp,GASY2  ,
OPT_7     , pcmd,'7' , scfg,VBAUD2 , sval,VBAUD2 , pmen,MASY2  , pgrp,GASY2  ,
OPT_8     , pcmd,'8' , scfg,VBAUD2 , sval,VBAUD2 , pmen,MASY2  , pgrp,GASY2  ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MASY2  , pgrp,GASY2  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RBAUD2 , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const char *const tag_baud[]  = { "BAUDS=600"   , "BAUDS=1200"  , 
                                         "BAUDS=2400"  , "BAUDS=9600"  , 
                                         "BAUDS=19200" , "BAUDS=38400" , 
                                         "BAUDS=57600" , "BAUDS=115200"    } ;


/* Serial line number of bits per symbol configuration MBITS const data .....*/

static const char *mbits =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   Select number of bits per symbol for ####                  |\n\r"
"  |                                                              |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |   | 1  6 bits per symbol                  |                  |\n\r"
"  |   | 2  7 bits per symbol                  |                  |\n\r"
"  |   | 3  8 bits per symbol                  |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   | 0  Back to list of options            |                  |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |                                                              |\n\r"
"  |   Enter command :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                           ;

static const M_trans tbits1[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VBITS1 , sval,VBITS1 , pmen,MASY1  , pgrp,GASY1  ,
OPT_2     , pcmd,'2' , scfg,VBITS1 , sval,VBITS1 , pmen,MASY1  , pgrp,GASY1  ,
OPT_3     , pcmd,'3' , scfg,VBITS1 , sval,VBITS1 , pmen,MASY1  , pgrp,GASY1  ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MASY1  , pgrp,GASY1  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RBITS1 , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const M_trans tbits2[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VBITS2 , sval,VBITS2 , pmen,MASY2  , pgrp,GASY2  ,
OPT_2     , pcmd,'2' , scfg,VBITS2 , sval,VBITS2 , pmen,MASY2  , pgrp,GASY2  ,
OPT_3     , pcmd,'3' , scfg,VBITS2 , sval,VBITS2 , pmen,MASY2  , pgrp,GASY2  ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MASY2  , pgrp,GASY2  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RBITS2 , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const char *const tag_bits[]  = { "NBBITS=6"    , "NBBITS=7"    ,
                                         "NBBITS=8"                        } ;


/* Serial line stop bits configuration MSTOP const data .....................*/

static const char *mstop =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   Select number of stop bits for ####                        |\n\r"
"  |                                                              |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |   | 1  1 stop bit                         |                  |\n\r"
"  |   | 2  2 stop bits                        |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   | 0  Back to list of options            |                  |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |                                                              |\n\r"
"  |   Enter command :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                           ;

static const M_trans tstop1[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VSTOP1 , sval,VSTOP1 , pmen,MASY1  , pgrp,GASY1  ,
OPT_2     , pcmd,'2' , scfg,VSTOP1 , sval,VSTOP1 , pmen,MASY1  , pgrp,GASY1  ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MASY1  , pgrp,GASY1  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RSTOP1 , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const M_trans tstop2[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VSTOP2 , sval,VSTOP2 , pmen,MASY2  , pgrp,GASY2  ,
OPT_2     , pcmd,'2' , scfg,VSTOP2 , sval,VSTOP2 , pmen,MASY2  , pgrp,GASY2  ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MASY2  , pgrp,GASY2  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RSTOP2 , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const char *const tag_stop[]  = { "STOPBIT=1"   , "STOPBIT=2"       } ;


/* Serial line parity configuration MPAR const data .........................*/

static const char *mpar =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   Select parity for ####                                     |\n\r"
"  |                                                              |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |   | 1  No parity                          |                  |\n\r"
"  |   | 2  Even parity                        |                  |\n\r"
"  |   | 3  Odd parity                         |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   | 0  Back to list of options            |                  |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |                                                              |\n\r"
"  |   Enter command :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                           ;

static const M_trans tpar1[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VPAR1  , sval,VPAR1  , pmen,MASY1  , pgrp,GASY1  ,
OPT_2     , pcmd,'2' , scfg,VPAR1  , sval,VPAR1  , pmen,MASY1  , pgrp,GASY1  ,
OPT_3     , pcmd,'3' , scfg,VPAR1  , sval,VPAR1  , pmen,MASY1  , pgrp,GASY1  ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MASY1  , pgrp,GASY1  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RPAR1  , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const M_trans tpar2[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VPAR2  , sval,VPAR2  , pmen,MASY2  , pgrp,GASY2  ,
OPT_2     , pcmd,'2' , scfg,VPAR2  , sval,VPAR2  , pmen,MASY2  , pgrp,GASY2  ,
OPT_3     , pcmd,'3' , scfg,VPAR2  , sval,VPAR2  , pmen,MASY2  , pgrp,GASY2  ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MASY2  , pgrp,GASY2  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RPAR2  , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const char *const tag_par []  = { "PARITY=NONE" , "PARITY=EVEN" ,
                                         "PARITY=ODD"                      } ;


/* Serial line flow control configuration MFLOW const data ..................*/

static const char *mflow =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   Select flow control mode for ####                          |\n\r"
"  |                                                              |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |   | 1  No flow control                    |                  |\n\r"
"  |   | 2  Flow control with RTS/CTS          |                  |\n\r"
"  |   | 3  Flow control with XON/XOFF         |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   | 0  Back to list of options            |                  |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |                                                              |\n\r"
"  |   Enter command :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                           ;

static const M_trans tflow1[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VFLOW1 , sval,VFLOW1 , pmen,MASY1  , pgrp,GASY1  ,
OPT_2     , pcmd,'2' , scfg,VFLOW1 , sval,VFLOW1 , pmen,MASY1  , pgrp,GASY1  ,
OPT_3     , pcmd,'3' , scfg,VFLOW1 , sval,VFLOW1 , pmen,MASY1  , pgrp,GASY1  ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MASY1  , pgrp,GASY1  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RFLOW1 , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const M_trans tflow2[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VFLOW2 , sval,VFLOW2 , pmen,MASY2  , pgrp,GASY2  ,
OPT_2     , pcmd,'2' , scfg,VFLOW2 , sval,VFLOW2 , pmen,MASY2  , pgrp,GASY2  ,
OPT_3     , pcmd,'3' , scfg,VFLOW2 , sval,VFLOW2 , pmen,MASY2  , pgrp,GASY2  ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MASY2  , pgrp,GASY2  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RFLOW2 , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const char *const str_flow [] = { "NO FCTL", "RTS/CTS", "XON/OFF"   } ;

static const char *const tag_flow [] = { "FLOWCTL=NONE", "FLOWCTL=RTS/CTS",
                                         "FLOWCTL=XON/XOFF"                } ;


/* Serial line reception flush configuration MFLUSH const data ..............*/

static const char *mflush =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   Select reception flush mode for ####                       |\n\r"
"  |                                                              |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |   | 1  When buffer is full only           |                  |\n\r"
"  |   | 2  Character temporization            |                  |\n\r"
"  |   | 3  Frame temporization                |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   | 0  Back to list of options            |                  |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |                                                              |\n\r"
"  |   Enter command :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                           ;

static const M_trans tflush1[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VFLUSH1, sval,VFLUSH1, pmen,MASY1  , pgrp,GASY1  ,
OPT_2     , pcmd,'2' , scfg,VFLUSH1, sval,VFLUSH1, pmen,MASY1  , pgrp,GASY1  ,
OPT_3     , pcmd,'3' , scfg,VFLUSH1, sval,VFLUSH1, pmen,MASY1  , pgrp,GASY1  ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MASY1  , pgrp,GASY1  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RFLUSH1, pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const M_trans tflush2[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VFLUSH2, sval,VFLUSH2, pmen,MASY2  , pgrp,GASY2  ,
OPT_2     , pcmd,'2' , scfg,VFLUSH2, sval,VFLUSH2, pmen,MASY2  , pgrp,GASY2  ,
OPT_3     , pcmd,'3' , scfg,VFLUSH2, sval,VFLUSH2, pmen,MASY2  , pgrp,GASY2  ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MASY2  , pgrp,GASY2  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RFLUSH2, pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const char *const tag_flush[] = { "TMODE=NONE"  , "TMODE=CHARACTER",
                                         "TMODE=FRAME"                     } ;


/* Serial line reception timing configuration MTEMPO const data .............*/

static const char *mtempo =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   Select reception temporization duration for ####           |\n\r"
"  |                                                              |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |   | 1  1 ms                               |                  |\n\r"
"  |   | 2  5 ms                               |                  |\n\r"
"  |   | 3  10 ms                              |                  |\n\r"
"  |   | 4  50 ms                              |                  |\n\r"
"  |   | 5  100 ms                             |                  |\n\r"
"  |   | 6  150 ms                             |                  |\n\r"
"  |   | 7  200 ms                             |                  |\n\r"
"  |   | 8  500 ms                             |                  |\n\r"
"  |   | 9  1000 ms                            |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   | 0  Back to list of options            |                  |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |                                                              |\n\r"
"  |   Enter command :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                           ;

static const M_trans ttempo1[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VTEMPO1, sval,VTEMPO1, pmen,MASY1  , pgrp,GASY1  ,
OPT_2     , pcmd,'2' , scfg,VTEMPO1, sval,VTEMPO1, pmen,MASY1  , pgrp,GASY1  ,
OPT_3     , pcmd,'3' , scfg,VTEMPO1, sval,VTEMPO1, pmen,MASY1  , pgrp,GASY1  ,
OPT_4     , pcmd,'4' , scfg,VTEMPO1, sval,VTEMPO1, pmen,MASY1  , pgrp,GASY1  ,
OPT_5     , pcmd,'5' , scfg,VTEMPO1, sval,VTEMPO1, pmen,MASY1  , pgrp,GASY1  ,
OPT_6     , pcmd,'6' , scfg,VTEMPO1, sval,VTEMPO1, pmen,MASY1  , pgrp,GASY1  ,
OPT_7     , pcmd,'7' , scfg,VTEMPO1, sval,VTEMPO1, pmen,MASY1  , pgrp,GASY1  ,
OPT_8     , pcmd,'8' , scfg,VTEMPO1, sval,VTEMPO1, pmen,MASY1  , pgrp,GASY1  ,
OPT_9     , pcmd,'9' , scfg,VTEMPO1, sval,VTEMPO1, pmen,MASY1  , pgrp,GASY1  ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MASY1  , pgrp,GASY1  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RTEMPO1, pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const M_trans ttempo2[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VTEMPO2, sval,VTEMPO2, pmen,MASY2  , pgrp,GASY2  ,
OPT_2     , pcmd,'2' , scfg,VTEMPO2, sval,VTEMPO2, pmen,MASY2  , pgrp,GASY2  ,
OPT_3     , pcmd,'3' , scfg,VTEMPO2, sval,VTEMPO2, pmen,MASY2  , pgrp,GASY2  ,
OPT_4     , pcmd,'4' , scfg,VTEMPO2, sval,VTEMPO2, pmen,MASY2  , pgrp,GASY2  ,
OPT_5     , pcmd,'5' , scfg,VTEMPO2, sval,VTEMPO2, pmen,MASY2  , pgrp,GASY2  ,
OPT_6     , pcmd,'6' , scfg,VTEMPO2, sval,VTEMPO2, pmen,MASY2  , pgrp,GASY2  ,
OPT_7     , pcmd,'7' , scfg,VTEMPO2, sval,VTEMPO2, pmen,MASY2  , pgrp,GASY2  ,
OPT_8     , pcmd,'8' , scfg,VTEMPO2, sval,VTEMPO2, pmen,MASY2  , pgrp,GASY2  ,
OPT_9     , pcmd,'9' , scfg,VTEMPO2, sval,VTEMPO2, pmen,MASY2  , pgrp,GASY2  ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MASY2  , pgrp,GASY2  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RTEMPO2, pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const char *const str_tempo[] = { "TEMPO=1"    , "TEMPO=5"   ,
                                         "TEMPO=10"   , "TEMPO=50"  ,
                                         "TEMPO=100"  , "TEMPO=150" ,
                                         "TEMPO=200"  , "TEMPO=500" ,
                                         "TEMPO=1000"                      } ;


/* GPIO options list MGPIO const data .......................................*/

static const char *mgpio =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   Configure gpio                                             |\n\r"
"  |                                                              |\n\r"
"  |   +---------------------------------------+  +-----------+   |\n\r"
"  |   | 1  Set software polling delay         |  |  -------  |   |\n\r"
"  |   | 2  Set software polling count         |  |  -------  |   |\n\r"
"  |   | 3  Set BUT1/BUT2/BUT3 parameters      |  +-----------+   |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   | 0  Back to configure menu             |                  |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |                                                              |\n\r"
"  |   Enter command :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                                ;

static const M_trans tgpio[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , empt,'X'    , empt,'X'    , pmen,MPTIM  , empt,'X'    ,
OPT_2     , pcmd,'2' , empt,'X'    , empt,'X'    , pmen,MPCNT  , empt,'X'    ,
OPT_3     , pcmd,'3' , empt,'X'    , empt,'X'    , pmen,MBUT   , pgrp,GBUT   ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MCONF  , pgrp,GCONF  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RGPIO  , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const char *const str_spdly[] = { "  10 MS", "  20 MS", "  50 MS",
                                         "  75 MS", " 100 MS",             } ;

static const char *const str_spcnt[] = { "      1", "      2", "      3",
                                         "      4", "      5",             } ;

/* Software polling delay configuration MPTIM const data ....................*/

static const char *mptim =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   Select software polling delay                              |\n\r"
"  |                                                              |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |   | 1  10 milliseconds                    |                  |\n\r"
"  |   | 2  20 milliseconds                    |                  |\n\r"
"  |   | 3  50 milliseconds                    |                  |\n\r"
"  |   | 4  75 milliseconds                    |                  |\n\r"
"  |   | 5  100 milliseconds                   |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   | 0  Back to configure gpio             |                  |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |                                                              |\n\r"
"  |   Enter command :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                           ;

static const M_trans tptim[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VPTIM  , sval,VPTIM  , pmen,MGPIO  , pgrp,GGPIO  ,
OPT_2     , pcmd,'2' , scfg,VPTIM  , sval,VPTIM  , pmen,MGPIO  , pgrp,GGPIO  ,
OPT_3     , pcmd,'3' , scfg,VPTIM  , sval,VPTIM  , pmen,MGPIO  , pgrp,GGPIO  ,
OPT_4     , pcmd,'4' , scfg,VPTIM  , sval,VPTIM  , pmen,MGPIO  , pgrp,GGPIO  ,
OPT_5     , pcmd,'5' , scfg,VPTIM  , sval,VPTIM  , pmen,MGPIO  , pgrp,GGPIO  ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MGPIO  , pgrp,GGPIO  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RPTIM  , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const char *const tag_polltim[]= { "POLLTIM=10" , "POLLTIM=20",
                                          "POLLTIM=50" , "POLLTIM=75",
                                          "POLLTIM=100"                    } ;


/* Software polling count configuration MPCNT const data ....................*/

static const char *mpcnt =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   Select software polling count                              |\n\r"
"  |                                                              |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |   | 1  1 time                             |                  |\n\r"    
"  |   | 2  2 times                            |                  |\n\r"
"  |   | 3  3 times                            |                  |\n\r"
"  |   | 4  4 times                            |                  |\n\r"    
"  |   | 5  5 times                            |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"    
"  |   |                                       |                  |\n\r"
"  |   | 0  Back to configure gpio             |                  |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |                                                              |\n\r"
"  |   Enter command :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                           ;

static const M_trans tpcnt[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VPCNT  , sval,VPCNT  , pmen,MGPIO  , pgrp,GGPIO  ,
OPT_2     , pcmd,'2' , scfg,VPCNT  , sval,VPCNT  , pmen,MGPIO  , pgrp,GGPIO  ,
OPT_3     , pcmd,'3' , scfg,VPCNT  , sval,VPCNT  , pmen,MGPIO  , pgrp,GGPIO  ,
OPT_4     , pcmd,'4' , scfg,VPCNT  , sval,VPCNT  , pmen,MGPIO  , pgrp,GGPIO  ,
OPT_5     , pcmd,'5' , scfg,VPCNT  , sval,VPCNT  , pmen,MGPIO  , pgrp,GGPIO  ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MGPIO  , pgrp,GGPIO  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RPCNT  , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const char *const tag_pollcnt[]= { "POLLCNT=1"  , "POLLCNT=2" ,
                                          "POLLCNT=3"  , "POLLCNT=4" ,
                                          "POLLCNT=5"                      } ;

/* Buttons options list MBUT const data .....................................*/

static const char *mbut =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   Configure BUT1/BUT1/BUT3                                   |\n\r"
"  |                                                              |\n\r"
"  |   +---------------------------------------+  +-----------+   |\n\r"
"  |   | 1  Set BUT1 monitor mode              |  |  -------  |   |\n\r"
"  |   | 2           hardware polling delay    |  |  -------  |   |\n\r"
"  |   | 3           hardware polling count    |  |  -------  |   |\n\r"
"  |   | 4  Set BUT2 monitor mode              |  |  -------  |   |\n\r"
"  |   | 5           hardware polling delay    |  |  -------  |   |\n\r"
"  |   | 6           hardware polling count    |  |  -------  |   |\n\r"
"  |   | 7  Set BUT3 monitor mode              |  |  -------  |   |\n\r"
"  |   | 8           hardware polling delay    |  |  -------  |   |\n\r"
"  |   | 9           hardware polling count    |  |  -------  |   |\n\r"
"  |   |                                       |  +-----------+   |\n\r"
"  |   | 0  Back to previous menu              |                  |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |                                                              |\n\r"
"  |   Enter command :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                                ;

static const M_trans tbut[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , empt,'X'    , empt,'X'    , pmen,MMON1  , empt,'X'    ,
OPT_2     , pcmd,'2' , empt,'X'    , empt,'X'    , pmen,MDTIM1 , empt,'X'    ,
OPT_3     , pcmd,'3' , empt,'X'    , empt,'X'    , pmen,MDCNT1 , empt,'X'    ,
OPT_4     , pcmd,'4' , empt,'X'    , empt,'X'    , pmen,MMON2  , empt,'X'    ,
OPT_5     , pcmd,'5' , empt,'X'    , empt,'X'    , pmen,MDTIM2 , empt,'X'    ,
OPT_6     , pcmd,'6' , empt,'X'    , empt,'X'    , pmen,MDCNT2 , empt,'X'    ,
OPT_7     , pcmd,'7' , empt,'X'    , empt,'X'    , pmen,MMON3  , empt,'X'    ,
OPT_8     , pcmd,'8' , empt,'X'    , empt,'X'    , pmen,MDTIM3 , empt,'X'    ,
OPT_9     , pcmd,'9' , empt,'X'    , empt,'X'    , pmen,MDCNT3 , empt,'X'    ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MGPIO  , pgrp,GGPIO  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RBUT   , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const char *const str_monit[] = { "   POLL", "   DIFI", "    IRQ"   } ;

static const char *const str_hpdly[] = { "  10 US", "  20 US", "  50 US",
                                         "  75 US", " 100 US",             } ;

/* Monitor mode configuration MMON1/MMON3/MMON4 const data ..................*/

static const char *mmon123 =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   Select monitor mode for ####                               |\n\r"
"  |                                                              |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |   | 1  Polling                            |                  |\n\r"    
"  |   | 2  Digital Filtering                  |                  |\n\r"
"  |   | 3  IRQ                                |                  |\n\r"
"  |   |                                       |                  |\n\r"    
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"    
"  |   |                                       |                  |\n\r"
"  |   | 0  Back to previous menu              |                  |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |                                                              |\n\r"
"  |   Enter command :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                           ;

static const M_trans tmon1[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VMON1  , sval,VMON1  , pmen,MBUT   , pgrp,GBUT   ,
OPT_2     , pcmd,'2' , scfg,VMON1  , sval,VMON1  , pmen,MBUT   , pgrp,GBUT   ,
OPT_3     , pcmd,'3' , scfg,VMON1  , sval,VMON1  , pmen,MBUT   , pgrp,GBUT   ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MBUT   , pgrp,GBUT   ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RMON1  , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const M_trans tmon2[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VMON2  , sval,VMON2  , pmen,MBUT   , pgrp,GBUT   ,
OPT_2     , pcmd,'2' , scfg,VMON2  , sval,VMON2  , pmen,MBUT   , pgrp,GBUT   ,
OPT_3     , pcmd,'3' , scfg,VMON2  , sval,VMON2  , pmen,MBUT   , pgrp,GBUT   ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MBUT   , pgrp,GBUT   ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RMON2  , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const M_trans tmon3[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VMON3  , sval,VMON3  , pmen,MBUT   , pgrp,GBUT   ,
OPT_2     , pcmd,'2' , scfg,VMON3  , sval,VMON3  , pmen,MBUT   , pgrp,GBUT   ,
OPT_3     , pcmd,'3' , scfg,VMON3  , sval,VMON3  , pmen,MBUT   , pgrp,GBUT   ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MBUT   , pgrp,GBUT   ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RMON3  , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const char *const tag_monit[] = { "MONITOR=POLL"   , "MONITOR=DIFI" ,
                                         "MONITOR=IRQ"                     } ;


/* Hardware polling delay configuration MDTIM/MDTIM2/MDTIM3 const data ......*/

static const char *mdtim123 =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   Select hardware polling delay for ####                     |\n\r"
"  |                                                              |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |   | 1  10 microseconds                    |                  |\n\r"
"  |   | 2  20 microseconds                    |                  |\n\r"
"  |   | 3  50 microseconds                    |                  |\n\r"
"  |   | 4  75 microseconds                    |                  |\n\r"
"  |   | 5  100 microseconds                   |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   | 0  Back to previous menu              |                  |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |                                                              |\n\r"
"  |   Enter command :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                                ;
   
static const M_trans tdtim1[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VDTIM1 , sval,VDTIM1 , pmen,MBUT   , pgrp,GBUT   ,
OPT_2     , pcmd,'2' , scfg,VDTIM1 , sval,VDTIM1 , pmen,MBUT   , pgrp,GBUT   ,
OPT_3     , pcmd,'3' , scfg,VDTIM1 , sval,VDTIM1 , pmen,MBUT   , pgrp,GBUT   ,
OPT_4     , pcmd,'4' , scfg,VDTIM1 , sval,VDTIM1 , pmen,MBUT   , pgrp,GBUT   ,
OPT_5     , pcmd,'5' , scfg,VDTIM1 , sval,VDTIM1 , pmen,MBUT   , pgrp,GBUT   ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MBUT   , pgrp,GBUT   ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RDTIM1 , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const M_trans tdtim2[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VDTIM2 , sval,VDTIM2 , pmen,MBUT   , pgrp,GBUT   ,
OPT_2     , pcmd,'2' , scfg,VDTIM2 , sval,VDTIM2 , pmen,MBUT   , pgrp,GBUT   ,
OPT_3     , pcmd,'3' , scfg,VDTIM2 , sval,VDTIM2 , pmen,MBUT   , pgrp,GBUT   ,
OPT_4     , pcmd,'4' , scfg,VDTIM2 , sval,VDTIM2 , pmen,MBUT   , pgrp,GBUT   ,
OPT_5     , pcmd,'5' , scfg,VDTIM2 , sval,VDTIM2 , pmen,MBUT   , pgrp,GBUT   ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MBUT   , pgrp,GBUT   ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RDTIM2 , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const M_trans tdtim3[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VDTIM3 , sval,VDTIM3 , pmen,MBUT   , pgrp,GBUT   ,
OPT_2     , pcmd,'2' , scfg,VDTIM3 , sval,VDTIM3 , pmen,MBUT   , pgrp,GBUT   ,
OPT_3     , pcmd,'3' , scfg,VDTIM3 , sval,VDTIM3 , pmen,MBUT   , pgrp,GBUT   ,
OPT_4     , pcmd,'4' , scfg,VDTIM3 , sval,VDTIM3 , pmen,MBUT   , pgrp,GBUT   ,
OPT_5     , pcmd,'5' , scfg,VDTIM3 , sval,VDTIM3 , pmen,MBUT   , pgrp,GBUT   ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MBUT   , pgrp,GBUT   ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RDTIM3 , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const char *const tag_difitim[] = { "DIFITIM=10" , "DIFITIM=20" ,
                                           "DIFITIM=50" , "DIFITIM=75" ,
                                           "DIFITIM=100"                   } ;


/* Hardware polling count configuration MDCNT1/MDCNT2/MDCNT3 const data .....*/

static const char *mdcnt123 =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   Select hardware polling count for ####                     |\n\r"
"  |                                                              |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |   | 1  1 time                             |                  |\n\r"
"  |   | 2  2 times                            |                  |\n\r"
"  |   | 3  3 times                            |                  |\n\r"
"  |   | 4  4 times                            |                  |\n\r"
"  |   | 5  5 times                            |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   |                                       |                  |\n\r"
"  |   | 0  Back to previous menu              |                  |\n\r"
"  |   +---------------------------------------+                  |\n\r"
"  |                                                              |\n\r"
"  |   Enter command :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                                ;

static const M_trans tdcnt1[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VDCNT1 , sval,VDCNT1 , pmen,MBUT   , pgrp,GBUT   ,
OPT_2     , pcmd,'2' , scfg,VDCNT1 , sval,VDCNT1 , pmen,MBUT   , pgrp,GBUT   ,
OPT_3     , pcmd,'3' , scfg,VDCNT1 , sval,VDCNT1 , pmen,MBUT   , pgrp,GBUT   ,
OPT_4     , pcmd,'4' , scfg,VDCNT1 , sval,VDCNT1 , pmen,MBUT   , pgrp,GBUT   ,
OPT_5     , pcmd,'5' , scfg,VDCNT1 , sval,VDCNT1 , pmen,MBUT   , pgrp,GBUT   ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MBUT   , pgrp,GBUT   ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RDCNT1 , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const M_trans tdcnt2[] = { /*

Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VDCNT2 , sval,VDCNT2 , pmen,MBUT   , pgrp,GBUT   ,
OPT_2     , pcmd,'2' , scfg,VDCNT2 , sval,VDCNT2 , pmen,MBUT   , pgrp,GBUT   ,
OPT_3     , pcmd,'3' , scfg,VDCNT2 , sval,VDCNT2 , pmen,MBUT   , pgrp,GBUT   ,
OPT_4     , pcmd,'4' , scfg,VDCNT2 , sval,VDCNT2 , pmen,MBUT   , pgrp,GBUT   ,
OPT_5     , pcmd,'5' , scfg,VDCNT2 , sval,VDCNT2 , pmen,MBUT   , pgrp,GBUT   ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MBUT   , pgrp,GBUT   ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RDCNT2 , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const M_trans tdcnt3[] = { /*

Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , scfg,VDCNT3 , sval,VDCNT3 , pmen,MBUT   , pgrp,GBUT   ,
OPT_2     , pcmd,'2' , scfg,VDCNT3 , sval,VDCNT3 , pmen,MBUT   , pgrp,GBUT   ,
OPT_3     , pcmd,'3' , scfg,VDCNT3 , sval,VDCNT3 , pmen,MBUT   , pgrp,GBUT   ,
OPT_4     , pcmd,'4' , scfg,VDCNT3 , sval,VDCNT3 , pmen,MBUT   , pgrp,GBUT   ,
OPT_5     , pcmd,'5' , scfg,VDCNT3 , sval,VDCNT3 , pmen,MBUT   , pgrp,GBUT   ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MBUT   , pgrp,GBUT   ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RDCNT3 , pmen,MERR   , perr,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const char *const tag_dificnt[] = { "DIFICNT=1"  , "DIFICNT=2"  ,
                                           "DIFICNT=3"  , "DIFICNT=4"  ,
                                           "DIFICNT=5"                     } ;

/* RCU options list MRCU const data .........................................*/

static const char *mrcu =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   Configure RCU                                              |\n\r"
"  |                                                              |\n\r"
"  |   +--------------------------------+  +------------------+   |\n\r"
"  |   | 1  Select RCU receiver input   |  | ---------------- |   |\n\r"
"  |   | 2  Select RCU name             |  | ---------------- |   |\n\r"
"  |   | 3  Select START ON  min        |  | ---------------- |   |\n\r"
"  |   | 4  Select START ON  max        |  | ---------------- |   |\n\r"
"  |   | 5  Select START OFF min        |  | ---------------- |   |\n\r"
"  |   | 6  Select START OFF max        |  | ---------------- |   |\n\r"
"  |   |                                |  +------------------+   |\n\r"
"  |   | 7  Capture symbols             |                         |\n\r"
"  |   |                                |                         |\n\r"
"  |   |                                |                         |\n\r"
"  |   | 0  Back to configure menu      |                         |\n\r"
"  |   +--------------------------------+                         |\n\r"
"  |                                                              |\n\r"
"  |   Enter command :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                                ;

static const M_trans trcu[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_1     , pcmd,'1' , tinp,VINPUT , srcu,'X'    , tssy,'X'    , pgrp,GRCU   ,
OPT_2     , pcmd,'2' , tinp,VNUMRCU, srcu,'X'    , tssy,'X'    , pgrp,GRCU   ,
OPT_3     , pcmd,'3' , empt,'X'    , empt,'X'    , pmen,MOTMIN , pgrp,GRCU   ,
OPT_4     , pcmd,'4' , empt,'X'    , empt,'X'    , pmen,MOTMAX , pgrp,GRCU   ,
OPT_5     , pcmd,'5' , empt,'X'    , empt,'X'    , pmen,MSTMIN , pgrp,GRCU   ,
OPT_6     , pcmd,'6' , empt,'X'    , empt,'X'    , pmen,MSTMAX , pgrp,GRCU   ,
OPT_7     , pcmd,'7' , empt,'X'    , scap,'X'    , pmen,MCAP   , empt,'X'    ,
OPT_0     , pcmd,'0' , empt,'X'    , empt,'X'    , pmen,MCONF  , pgrp,GCONF  ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
OPT_ERROR , empt,'X' , empt,'X'    , sret,RRCU   , pmen,MERR   , perr,'X'    ,
DEFAULT   , pcmd,'?' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const char *const str_input[] = { "IR  input ", "UHF input "        } ;

#define NBRCU_IR    2
#define NBRCU_UHF   2

static const char vnumrcu[] = {0, NBRCU_IR};

static const char *const str_rcuna[] = 
          { /* IR input */ "ECEL JU090601", "CAPTURE NEC", 
            /* UHF input*/ "DIO 54760"    , "CAPTURE DIO",                 } ;


/* Selects start symbol parameters MOTMIN/MOTMAX/MSTMIN/MSTMAX const data....*/
static const char *msym =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   Select start symbol ###### duration                        |\n\r"
"  |                                                              |\n\r"
"  |   +--------------------------------+  +------------------+   |\n\r"
"  |   |    Current RCU receiver input  |  | ---------------- |   |\n\r"
"  |   |    Current RCU name            |  | ---------------- |   |\n\r"
"  |   |    Current START ON  min       |  | ---------------- |   |\n\r"
"  |   |    Current START ON  max       |  | ---------------- |   |\n\r"
"  |   |    Current START OFF min       |  | ---------------- |   |\n\r"
"  |   |    Current START OFF max       |  | ---------------- |   |\n\r"
"  |   |                                |  +------------------+   |\n\r"
"  |   |    0..9 .......... Digit       |                         |\n\r"
"  |   |    OK/Return ....... End       |                         |\n\r"
"  |   |    BACK/Backspace  Erase       |                         |\n\r"
"  |   |    EXIT/Escape .. Cancel       |                         |\n\r"
"  |   +--------------------------------+                         |\n\r"
"  |                                                              |\n\r"
"  |   Enter integer :                                            |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                                ;

static const M_trans totmin[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_0     , pchr,'0' , tchr,'0'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_1     , pchr,'1' , tchr,'1'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_2     , pchr,'2' , tchr,'2'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_3     , pchr,'3' , tchr,'3'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_4     , pchr,'4' , tchr,'4'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_5     , pchr,'5' , tchr,'5'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_6     , pchr,'6' , tchr,'6'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_7     , pchr,'7' , tchr,'7'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_8     , pchr,'8' , tchr,'7'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_9     , pchr,'9' , tchr,'9'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_BACK  , pchr, 8  , tchr, 8     , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_ENTER , empt,'X' , sint,VONMIN , empt,'X'    , pmen,MRCU   , pgrp,GRCU   ,
OPT_ESC   , empt,'X' , empt,'X'    , empt,'X'    , pmen,MRCU   , pgrp,GRCU   ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const M_trans totmax[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_0     , pchr,'0' , tchr,'0'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_1     , pchr,'1' , tchr,'1'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_2     , pchr,'2' , tchr,'2'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_3     , pchr,'3' , tchr,'3'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_4     , pchr,'4' , tchr,'4'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_5     , pchr,'5' , tchr,'5'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_6     , pchr,'6' , tchr,'6'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_7     , pchr,'7' , tchr,'7'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_8     , pchr,'8' , tchr,'8'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_9     , pchr,'9' , tchr,'9'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_BACK  , pchr, 8  , tchr, 8     , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_ENTER , empt,'X' , sint,VONMAX , empt,'X'    , pmen,MRCU   , pgrp,GRCU   ,
OPT_ESC   , empt,'X' , empt,'X'    , empt,'X'    , pmen,MRCU   , pgrp,GRCU   ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const M_trans tstmin[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_0     , pchr,'0' , tchr,'0'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_1     , pchr,'1' , tchr,'1'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_2     , pchr,'2' , tchr,'2'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_3     , pchr,'3' , tchr,'3'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_4     , pchr,'4' , tchr,'4'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_5     , pchr,'5' , tchr,'5'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_6     , pchr,'6' , tchr,'6'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_7     , pchr,'7' , tchr,'7'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_8     , pchr,'8' , tchr,'8'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_9     , pchr,'9' , tchr,'9'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_BACK  , pchr, 8  , tchr, 8     , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_ENTER , empt,'X' , sint,VSTMIN , empt,'X'    , pmen,MRCU   , pgrp,GRCU   ,
OPT_ESC   , empt,'X' , empt,'X'    , empt,'X'    , pmen,MRCU   , pgrp,GRCU   ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

static const M_trans tstmax[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_0     , pchr,'0' , tchr,'0'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_1     , pchr,'1' , tchr,'1'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_2     , pchr,'2' , tchr,'2'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_3     , pchr,'3' , tchr,'3'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_4     , pchr,'4' , tchr,'4'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_5     , pchr,'5' , tchr,'5'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_6     , pchr,'6' , tchr,'6'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_7     , pchr,'7' , tchr,'7'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_8     , pchr,'8' , tchr,'8'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_9     , pchr,'9' , tchr,'9'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_BACK  , pchr, 8  , tchr, 8     , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_ENTER , empt,'X' , sint,VSTMAX , empt,'X'    , pmen,MRCU   , pgrp,GRCU   ,
OPT_ESC   , empt,'X' , empt,'X'    , empt,'X'    , pmen,MRCU   , pgrp,GRCU   ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;

/* Capture of RCU symbols ...................................................*/

static const char *mcap =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  | =========== =========== =========== =========== ===========  |\n\r"
"  | ----- ----- ----- ----- ----- ----- ----- ----- ----- -----  |\n\r"
"  | ----- ----- ----- ----- ----- ----- ----- ----- ----- -----  |\n\r"
"  | ----- ----- ----- ----- ----- ----- ----- ----- ----- -----  |\n\r"
"  | ----- ----- ----- ----- ----- ----- ----- ----- ----- -----  |\n\r"
"  | ----- ----- ----- ----- ----- ----- ----- ----- ----- -----  |\n\r"
"  | ----- ----- ----- ----- ----- ----- ----- ----- ----- -----  |\n\r"
"  | ----- ----- ----- ----- ----- ----- ----- ----- ----- -----  |\n\r"
"  | ----- ----- ----- ----- ----- ----- ----- ----- ----- -----  |\n\r"
"  | ----- ----- ----- ----- ----- ----- ----- ----- ----- -----  |\n\r"
"  | ----- ----- ----- ----- ----- ----- ----- ----- ----- -----  |\n\r"
"  | ----- ----- ----- ----- ----- ----- ----- ----- ----- -----  |\n\r"
"  | ----- ----- ----- ----- ----- ----- ----- ----- ----- -----  |\n\r"
"  | ----- ----- ----- ----- ----- ----- ----- ----- ----- -----  |\n\r"
"  | =========== =========== =========== =========== ===========  |\n\r"
"  |                                                              |\n\r"
"  |   Capture symbols - Press one RCU key                        |\n\r"
"  |   then ESC/EXIT Back to Configure RCU                        |\n\r"
"  +==============================================================+\n\r"
"\x1B[22;43H"                                                                ;

static const M_trans tcap[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_ESC   , empt,'X' , empt,'X'    , empt,'X'    , pmen,MRCU   , pgrp,GRCU   ,
OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt,'X'    , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt,'X'    , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt,'X'    , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim,'X'    , empt,'X'    ,
OPT_CAPT  , pcap,'X' , empt,'X'    , empt,'X'    , empt,'X'    , empt,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt,'X'    , empt,'X'    ,
DEFAULT   , empt,'X' , empt,'X'    , empt,'X'    , empt,'X'    , empt,'X'    ,
}                                                                            ;

/* Error message ............................................................*/

static const char *merr =
"\x1B[H"                               // Move to top left corner
"  +==============================================================+\n\r"
"  |                                                              |\n\r"
"  |   SynapsOS STM32 Myapp                            XX:XX:XX   |\n\r"
"  |                                                              |\n\r"
"  |   An error has been encountered                              |\n\r"
"  |                                                              |\n\r"
"  |   +------------------------------------------------------+   |\n\r"
"  |   |                                                      |   |\n\r"
"  |   |                                                      |   |\n\r"
"  |   |                                                      |   |\n\r"
"  |   |                                                      |   |\n\r"
"  |   |                                                      |   |\n\r"
"  |   |                                                      |   |\n\r"
"  |   |                                                      |   |\n\r"
"  |   |                                                      |   |\n\r"
"  |   |                                                      |   |\n\r"
"  |   |                                                      |   |\n\r"
"  |   |                                                      |   |\n\r"
"  |   +------------------------------------------------------+   |\n\r"
"  |                                                              |\n\r"
"  |   ESC/EXIT Back                                              |\n\r"
"  |                                                              |\n\r"
"  +==============================================================+\n\r"
"\x1B[21;23H"                                                                ;

static const M_trans terr[] = { /*
     
Evt code    Trt 1      Trt 2         Trt 3         Trt 4         Trt 5
----------  ---------  -----------   -----------   -----------   ----------  */
OPT_ESC   , scon,'X' , empt,'X'    , empt,'X'    , empt,'X'    , empt,'X'    ,
RMAIN     , empt,'X' , empt,'X'    , empt,'X'    , pmen,MMAIN  , pgrp,GMAIN  ,
RI2C      , empt,'X' , empt,'X'    , empt,'X'    , pmen,MI2C   , empt,'X'    ,
RCONF     , empt,'X' , empt,'X'    , empt,'X'    , pmen,MCONF  , pgrp,GCONF  ,

RASY1P    , empt,'X' , empt,'X'    , empt,'X'    , pmen,MASY1PT, empt,'X'    ,
RASY2P    , empt,'X' , empt,'X'    , empt,'X'    , pmen,MASY2PT, empt,'X'    ,
RDACPT    , empt,'X' , empt,'X'    , empt,'X'    , pmen,MDACPT , empt,'X'    ,

RASY1     , empt,'X' , empt,'X'    , empt,'X'    , pmen,MASY1  , pgrp,GASY1  ,
RBAUD1    , empt,'X' , empt,'X'    , empt,'X'    , pmen,MBAUD1 , empt,'X'    ,
RBITS1    , empt,'X' , empt,'X'    , empt,'X'    , pmen,MBITS1 , empt,'X'    ,
RSTOP1    , empt,'X' , empt,'X'    , empt,'X'    , pmen,MSTOP1 , empt,'X'    ,
RPAR1     , empt,'X' , empt,'X'    , empt,'X'    , pmen,MPAR1  , empt,'X'    ,
RFLOW1    , empt,'X' , empt,'X'    , empt,'X'    , pmen,MFLOW1 , empt,'X'    ,
RFLUSH1   , empt,'X' , empt,'X'    , empt,'X'    , pmen,MFLUSH1, empt,'X'    ,
RTEMPO1   , empt,'X' , empt,'X'    , empt,'X'    , pmen,MTEMPO1, empt,'X'    ,

RASY2     , empt,'X' , empt,'X'    , empt,'X'    , pmen,MASY2  , pgrp,GASY2  ,
RBAUD2    , empt,'X' , empt,'X'    , empt,'X'    , pmen,MBAUD2 , empt,'X'    ,
RBITS2    , empt,'X' , empt,'X'    , empt,'X'    , pmen,MBITS2 , empt,'X'    ,
RSTOP2    , empt,'X' , empt,'X'    , empt,'X'    , pmen,MSTOP2 , empt,'X'    ,
RPAR2     , empt,'X' , empt,'X'    , empt,'X'    , pmen,MPAR2  , empt,'X'    ,
RFLOW2    , empt,'X' , empt,'X'    , empt,'X'    , pmen,MFLOW2 , empt,'X'    ,
RFLUSH2   , empt,'X' , empt,'X'    , empt,'X'    , pmen,MFLUSH2, empt,'X'    ,
RTEMPO2   , empt,'X' , empt,'X'    , empt,'X'    , pmen,MTEMPO2, empt,'X'    ,

RGPIO     , empt,'X' , empt,'X'    , empt,'X'    , pmen,MGPIO  , pgrp,GGPIO  ,
RPTIM     , empt,'X' , empt,'X'    , empt,'X'    , pmen,MPTIM  , empt,'X'    ,
RPCNT     , empt,'X' , empt,'X'    , empt,'X'    , pmen,MPCNT  , empt,'X'    ,
RBUT      , empt,'X' , empt,'X'    , empt,'X'    , pmen,MBUT   , pgrp,GBUT   ,
RMON1     , empt,'X' , empt,'X'    , empt,'X'    , pmen,MMON1  , empt,'X'    ,
RDTIM1    , empt,'X' , empt,'X'    , empt,'X'    , pmen,MDTIM1 , empt,'X'    ,
RDCNT1    , empt,'X' , empt,'X'    , empt,'X'    , pmen,MDCNT1 , empt,'X'    ,
RMON2     , empt,'X' , empt,'X'    , empt,'X'    , pmen,MMON2  , empt,'X'    ,
RDTIM2    , empt,'X' , empt,'X'    , empt,'X'    , pmen,MDTIM2 , empt,'X'    ,
RDCNT2    , empt,'X' , empt,'X'    , empt,'X'    , pmen,MDCNT2 , empt,'X'    ,
RMON3     , empt,'X' , empt,'X'    , empt,'X'    , pmen,MMON3  , empt,'X'    ,
RDTIM3    , empt,'X' , empt,'X'    , empt,'X'    , pmen,MDTIM3 , empt,'X'    ,
RDCNT3    , empt,'X' , empt,'X'    , empt,'X'    , pmen,MDCNT3 , empt,'X'    ,

RRCU      , empt,'X' , empt,'X'    , empt,'X'    , pmen,MRCU   , pgrp,GRCU   ,
ROTMIN    , empt,'X' , empt,'X'    , empt,'X'    , pmen,MOTMIN , pgrp,GRCU   ,
ROTMAX    , empt,'X' , empt,'X'    , empt,'X'    , pmen,MOTMAX , pgrp,GRCU   ,
RSTMIN    , empt,'X' , empt,'X'    , empt,'X'    , pmen,MSTMIN , pgrp,GRCU   ,
RSTMAX    , empt,'X' , empt,'X'    , empt,'X'    , pmen,MSTMAX , pgrp,GRCU   ,
RCAP      , empt,'X' , empt,'X'    , empt,'X'    , pmen,MCAP   , empt,'X'    ,

OPT_BUT1  , pcmd,'1' , tcfg,VRED   , sled,VRED   , empt, 'X'   , empt,'X'    ,
OPT_BUT2  , pcmd,'2' , tcfg,VGREEN , sled,VGREEN , empt, 'X'   , empt,'X'    ,
OPT_BUT3  , pcmd,'3' , tcfg,VYELLO , sled,VYELLO , empt, 'X'   , empt,'X'    ,
OPT_TIME  , empt,'X' , empt,'X'    , empt,'X'    , ptim, 'X'   , empt,'X'    ,
OPT_IGNO  , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
DEFAULT   , empt,'X' , empt,'X'    , empt,'X'    , empt, 'X'   , empt,'X'    ,
}                                                                            ;


/* Lists of lists of strings ................................................*/

static const char *const * const menu[NB_PAGES] =
  {
    &mmain   , &mi2c    , &mconf   ,
    &masypt  , &masypt  , &mdacpt  ,
    &masy    , &mbaud   , &mbits   , &mstop, &mpar, &mflow, &mflush, &mtempo,
    &masy    , &mbaud   , &mbits   , &mstop, &mpar, &mflow, &mflush, &mtempo,
    &mgpio   , &mptim   , &mpcnt   , &mbut ,
    &mmon123 , &mdtim123, &mdcnt123,
    &mmon123 , &mdtim123, &mdcnt123,
    &mmon123 , &mdtim123, &mdcnt123,
    &mrcu    ,
    &msym    , &msym    , &msym    , &msym,
    &mcap    ,
    &merr    ,
  }                                                                          ;

static const char *patch[NB_PAGES] =
  {
    HNULL    , HNULL    , HNULL    ,
    "ASY1"   , "ASY2"   , HNULL    ,
    "ASY1"   , "ASY1"   , "ASY1"   , "ASY1", "ASY1", "ASY1", "ASY1" , "ASY1" ,
    "ASY2"   , "ASY2"   , "ASY2"   , "ASY2", "ASY2", "ASY2", "ASY2" , "ASY2" ,
    HNULL    , HNULL    , HNULL    , HNULL ,
    HNULL    , HNULL    , HNULL    ,
    HNULL    , HNULL    , HNULL    ,
    HNULL    , HNULL    , HNULL    ,
    HNULL    ,
    "ON min" , "ON max" , "ST min" , "ST max" ,
    HNULL    ,
    HNULL    ,
  }                                                                          ;

static const M_trans * const m_trans[NB_PAGES] =
  {
     tmain  , ti2c   , tconf  ,
     tasy1pt, tasy2pt, tdacpt ,
     tasy1  , tbaud1 , tbits1 , tstop1, tpar1, tflow1, tflush1, ttempo1,
     tasy2  , tbaud2 , tbits2 , tstop2, tpar2, tflow2, tflush2, ttempo2,
     tgpio  , tptim  , tpcnt  , tbut  ,
     tmon1  , tdtim1 , tdcnt1 ,
     tmon2  , tdtim2 , tdcnt2 ,
     tmon3  , tdtim3 , tdcnt3 ,
     trcu   ,
     totmin , totmax , tstmin , tstmax ,
     tcap   ,
     terr   ,
  }                                                                          ;

static const char * const * const str_cfg[VMAX]   = 
  { 
    str_stat   , str_stat   , str_stat   , 
    str_stat   , str_stat   , str_stat   , str_stat   ,

    str_asypt  , str_asypt  , str_dacpt  ,

    str_baud   , str_bits   , str_stop   , 
    str_par    , str_dma    , str_flow   , 
    str_flush  , str_flto   , str_speed  , 

    str_baud   , str_bits   , str_stop   , 
    str_par    , str_dma    , str_flow   , 
    str_flush  , str_flto   , str_speed  , 

    str_spdly  , str_spcnt  , 
    str_monit  , str_hpdly  , str_spcnt  ,   
    str_monit  , str_hpdly  , str_spcnt  ,
    str_monit  , str_hpdly  , str_spcnt  ,
    str_input  , str_rcuna  , HNULL      , HNULL    , HNULL    , HNULL   
  }                                                                          ;

static const char * const * const str_tag[VMAX]   = 
  { 
    tag_led0   , tag_led1   , tag_led2   , 
    HNULL      , HNULL      , HNULL      , HNULL  ,

    HNULL      , HNULL      , HNULL      ,

    tag_baud   , tag_bits   , tag_stop   , 
    tag_par    , tag_bufsz  , tag_flow   , 
    tag_flush  , str_tempo  , HNULL      , 

    tag_baud   , tag_bits   , tag_stop   , 
    tag_par    , tag_bufsz  , tag_flow   , 
    tag_flush  , str_tempo  , HNULL      , 

    tag_polltim, tag_pollcnt, 
    tag_monit  , tag_difitim, tag_dificnt, 
    tag_monit  , tag_difitim, tag_dificnt,
    tag_monit  , tag_difitim, tag_dificnt,
    HNULL      , HNULL      , HNULL      , HNULL    , HNULL    , HNULL   
  }                                                                          ;

